using System.Collections.Generic;
using System.Security.Claims;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;

namespace GameStore.Controllers.Web
{
    public class CookieAccountController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        public IActionResult AccessDenied()
        {
            return View();
        }

        public async Task<IActionResult> SignIn(string name)
        {
            var claims = new List<Claim>
            {
                new Claim(ClaimTypes.Name, name),
                new Claim(ClaimTypes.Role, "administrator"),
            };

            if (name == "Pepa")
            {
                claims.Add(new Claim("EmployeeNumber", "444"));
            }

            await HttpContext.Authentication.SignInAsync("MyCookieMiddlewareInstance", new ClaimsPrincipal(new[]
            {
                new ClaimsIdentity(claims, "CustomCookieAuthentiation", ClaimTypes.Name, ClaimTypes.Role)
            }));

            return RedirectToAction("Index", "Games");
        }

        public async Task<IActionResult> SignOut()
        {
            await HttpContext.Authentication.SignOutAsync("MyCookieMiddlewareInstance");
            return RedirectToAction("Index");
        }
    }
}